<?php
/******************************
 * WoWRoster.net  Roster
 * Copyright 2002-2006
 * Licensed under the Creative Commons
 * "Attribution-NonCommercial-ShareAlike 2.5" license
 *
 * Short summary
 *  http://creativecommons.org/licenses/by-nc-sa/2.5/
 *
 * Full license information
 *  http://creativecommons.org/licenses/by-nc-sa/2.5/legalcode
 * -----------------------------
 *
 * $Id: request.php 13 2007-1-1 12:50:20Z Averen $
 *
 ******************************/

if ( !defined('ROSTER_INSTALLED') )
{
    exit('Detected invalid access to this file!');
}

// Check if we already assigned something to $content, if not, Declare it
if (!isset($content))
{
	$content = '';
}

if ( (!isset($_GET['item'])) || (empty($_GET['item'])) )
{
	$_GET['action'] = 'item_error';
}

if( (isset($_COOKIE['req_name'])) && (!empty($_COOKIE['req_name'])) )
{

	$name = $wowdb->escape(htmlspecialchars($_COOKIE['req_name']));

} else {

	$name = '';

}

switch( $_GET['action'] )
{
	case "requestsub":

		if( (!isset($_GET['accname'])) || (empty($_GET['accname'])) || (!isset($_GET['req_amount'])) || (empty($_GET['req_amount'])) )
		{
			$error = '';
			if( (!isset($_GET['accname'])) || (empty($_GET['accname'])) )
			{
				$error .= $wordings[$roster_conf['roster_lang']]['gb_err_name']."<br />\n";
			}
			if( (!isset($_GET['req_amount'])) || (empty($_GET['req_amount'])) )
			{
				$error .= $wordings[$roster_conf['roster_lang']]['gb_err_amount']."<br />\n";
			}

			$content .= border('sblue','start',$wordings[$roster_conf['roster_lang']]['gb_request']);
			$content .= "\n<table cellspacing='0' cellpadding='0'>\n";
			$content .= "\t<tr><td class='membersRow1'>".$error."</td></tr>\n";
			$content .= "</table>";
			$content .= border('sblue','end');

		} else {

			$accname = htmlspecialchars($wowdb->escape($_GET['accname']));

			setcookie("req_name", $accname, time()+60*60*24*30, "/");

			intval($_GET['req_amount']) < 1 ? $req_amount = 1 : $req_amount = intval($_GET['req_amount']);

			$itemid = htmlspecialchars($wowdb->escape($_GET['item']));
	
			$query = "SELECT member.name as member_name, member.member_id as member_id, item.* FROM `".ROSTER_ITEMSTABLE."` as item LEFT JOIN `".ROSTER_MEMBERSTABLE."` as member ON item.member_id=member.member_id WHERE item.item_id LIKE '".$itemid.":%' AND member.".$roster_conf['banker_fieldname']." LIKE '%".$roster_conf['banker_rankname']."%' AND item.item_parent!='bags' AND item.item_parent!='equip' AND item.item_tooltip NOT LIKE '%".$wordings[$roster_conf['roster_lang']]['tooltip_soulbound']."%' AND length( item.item_id ) >0 ORDER BY item.item_name";
			$result = $wowdb->query($query) or die_quietly($wowdb->error(),'Database Error',basename(__FILE__),__LINE__,$query);
			
			while($itemraw = $wowdb->fetch_assoc($result))
			{
	
				if( !isset( $itemdata['item'] ) )
				{
	
					$itemdata['item']['real_id'] = $itemid;
					$itemdata['item']['item_name'] = $itemraw['item_name'];
					$itemdata['item']['item_color'] = $itemraw['item_color'];
					$itemdata['item']['item_id'] = $itemraw['item_id'];
					$itemdata['item']['item_texture'] = $itemraw['item_texture'];
					$itemdata['item']['item_tooltip'] = $itemraw['item_tooltip'];
					$itemdata['item']['level'] = $itemraw['level'];
					$itemdata['item']['item_level'] = $itemraw['item_level'];
	
				}
	
				if( isset( $itemdata['bankers'][$itemraw['member_id']]) )
				{
					$itemdata['bankers'][$itemraw['member_id']] += $itemraw['item_quantity'];
				} else {
					$itemdata['bankers'][$itemraw['member_id']] = $itemraw['item_quantity'];
					$itemdata['bankernames'][$itemraw['member_id']]['name'] = $itemraw['member_name'];
					$itemdata['bankernames'][$itemraw['member_id']]['time'] = DateCharDataUpdated($itemraw['member_id']);
				}
		
				if( isset( $itemdata['quantity'] ) )
				{
					$itemdata['quantity'] += $itemraw['item_quantity'];
				} else {
					$itemdata['quantity'] = $itemraw['item_quantity'];
				}
	
			}

			$query = "SELECT * FROM `".ROSTER_GB_REQUESTSTABLE."` WHERE item_id LIKE '".$itemid.":%' AND upload = 0 AND deny = 0";

			$result = $wowdb->query($query) or die_quietly($wowdb->error(),'Database Error',basename(__FILE__),__LINE__,$query);
			
			if( $wowdb->num_rows($result) > 0 )
			{
				while( $reqdata = $wowdb->fetch_assoc($result) )
				{
						if( isset($reqitems[$reqdata['member_id']]) )
						{
							$reqitems[$reqdata['member_id']] += $reqdata['item_quantity'];
						} else {
							$reqitems[$reqdata['member_id']] = $reqdata['item_quantity'];
						}
				}
			

				foreach($reqitems as $bankerid => $bankerquan)
				{
					if( isset($itemdata['bankers'][$bankerid]) )
					{
						$itemdata['bankers'][$bankerid] -= $bankerquan;
						$itemdata['quantity'] -= $bankerquan;

						if($itemdata['bankers'][$bankerid] < 1)
						{
							unset($itemdata['bankers'][$bankerid]);
						}
					}
				}
			}

			if( $req_amount > $itemdata['quantity'] )
			{
				$content .= border('sblue','start',$wordings[$roster_conf['roster_lang']]['gb_request']);
				$content .= "\n<table cellspacing='0' cellpadding='0'>\n";
				$content .= "\t<tr><td class='membersRow1'>".$wordings[$roster_conf['roster_lang']]['gb_err_toobig']."</td></tr>\n";
				$content .= "</table>";
				$content .= border('sblue','end');

			} else {

				asort($itemdata['bankers']);
				reset($itemdata['bankers']);

				$qtemp = $req_amount;

				foreach( $itemdata['bankers'] as $bid => $bquan )
				{

					if( $qtemp == $bquan ){
						$uptbank[$bid] = $bquan;
						break;
					}elseif( $bquan - $qtemp < 0 ){
						$uptbank[$bid] = $bquan;
						$qtemp = $qtemp - $bquan;
					}elseif( $bquan - $qtemp > 0 ){
						$uptbank[$bid] = $qtemp;
						break;
					}
				}

			$query = "SELECT name from `".ROSTER_MEMBERSTABLE."` WHERE member_id = '".$accname."'";
			$result = $wowdb->query($query) or die_quietly($wowdb->error(),'Database Error',basename(__FILE__),__LINE__,$query);
			$name = $wowdb->fetch_assoc($result);

			$updttime = time();

			$bankstr = '';
			foreach($uptbank as $bankid => $bankvalue)
			{
	
				$query = "INSERT into `".ROSTER_GB_REQUESTSTABLE."` (member_id, member_name, requester_id, requester_name, item_name, item_color, item_id, item_texture, item_quantity, item_tooltip, level, item_level, req_date) VALUES ('".$bankid."', '".$wowdb->escape($itemdata['bankernames'][$bankid]['name'])."', '".$accname."', '".$wowdb->escape($name['name'])."', '".$wowdb->escape($itemdata['item']['item_name'])."', '".$wowdb->escape($itemdata['item']['item_color'])."', '".$wowdb->escape($itemdata['item']['item_id'])."', '".$wowdb->escape($itemdata['item']['item_texture'])."', '".$wowdb->escape($bankvalue)."', '".$wowdb->escape($itemdata['item']['item_tooltip'])."', '".$wowdb->escape($itemdata['item']['level'])."', '".$wowdb->escape($itemdata['item']['item_level'])."', '".$updttime."')";
				$result = $wowdb->query($query) or die_quietly($wowdb->error(),'Database Error',basename(__FILE__),__LINE__,$query);

				$batchids[] = $wowdb->insert_id('req_id');

				$itemdata['bankers'][$bankid] -= $bankvalue;

				if($itemdata['bankers'][$bankid] < 1)
				{
					unset($itemdata['bankers'][$bankid]);
				}
	
				$bankstr .= $itemdata['bankernames'][$bankid]['name']." ( ".$bankvalue." )<br />\n";
			}
			$batch = '';
			foreach($batchids as $bid)
			{
				$batch .= $bid.":";
			}

			$batch = rtrim($batch, ":");

			foreach($batchids as $bid)
			{
				$query = "UPDATE `".ROSTER_GB_REQUESTSTABLE."` SET batch_id = '".$batch."' WHERE req_id = '".$bid."'";
				$result = $wowdb->query($query) or die_quietly($wowdb->error(),'Database Error',basename(__FILE__),__LINE__,$query);

			}
	
			$bankstr = substr($bankstr, 0, (strlen($bankstr)-7));
	
			$content .= border('sblue','start',$wordings[$roster_conf['roster_lang']]['gb_request']);
			$content .= "\n<table class='bodyline' cellspacing='0' cellpadding='0' align='center'>\n";
			$content .= "\t<tr><td class='membersRow1' rowspan='2'><center>".processItem($itemdata, $req_amount)."</center></td><td class='membersRowRight2'>".$wordings[$roster_conf['roster_lang']]['gb_char'].": ".$name['name']."</td></tr>\n";
			$content .= "\t<tr><td class='membersRowRight1'>".$wordings[$roster_conf['roster_lang']]['gb_amount'].": ".$req_amount."</td></tr>\n";
			$content .= "\t<tr><td class='membersRowRight2' colspan='2' ><center>".$bankstr."</center></td></tr>\n";
			$content .= "\t<tr><td class='membersRowRight1' colspan='2' ><center>".$wordings[$roster_conf['roster_lang']]['gb_comp']."</center></td></tr>\n";
			$content .= "</table>";
			$content .= border('sblue','end');

			}
		}

	break;
	case "request":

		$itemid = htmlspecialchars($wowdb->escape($_GET['item']));

		$query = "SELECT member.name as member_name, member.member_id as member_id, item.* FROM `".ROSTER_ITEMSTABLE."` as item LEFT JOIN `".ROSTER_MEMBERSTABLE."` as member ON item.member_id=member.member_id WHERE item.item_id LIKE '".$itemid.":%' AND member.".$roster_conf['banker_fieldname']." LIKE '%".$roster_conf['banker_rankname']."%' AND item.item_parent!='bags' AND item.item_parent!='equip' AND item.item_tooltip NOT LIKE '%".$wordings[$roster_conf['roster_lang']]['tooltip_soulbound']."%' ORDER BY item.item_name";
		$result = $wowdb->query($query) or die_quietly($wowdb->error(),'Database Error',basename(__FILE__),__LINE__,$query);
		
		while($itemraw = $wowdb->fetch_assoc($result))
		{

			if( !isset( $itemdata['item'] ) )
			{

				$itemdata['item']['real_id'] = $itemid;
				$itemdata['item']['item_name'] = $itemraw['item_name'];
				$itemdata['item']['item_color'] = $itemraw['item_color'];
				$itemdata['item']['item_id'] = $itemraw['item_id'];
				$itemdata['item']['item_texture'] = $itemraw['item_texture'];
				$itemdata['item']['item_tooltip'] = $itemraw['item_tooltip'];
				$itemdata['item']['level'] = $itemraw['level'];
				$itemdata['item']['item_level'] = $itemraw['item_level'];

			}

			if( strlen($itemraw['item_tooltip']) > strlen($itemdata['item']['item_tooltip']) )
			{
				$itemdata['item']['item_tooltip'] = $itemraw['item_tooltip'];
			}

			if( isset( $itemdata['bankers'][$itemraw['member_id']]) )
			{
				$itemdata['bankers'][$itemraw['member_id']] += $itemraw['item_quantity'];
			} else {
				$itemdata['bankers'][$itemraw['member_id']] = $itemraw['item_quantity'];
				$itemdata['bankernames'][$itemraw['member_id']]['name'] = $itemraw['member_name'];
				$itemdata['bankernames'][$itemraw['member_id']]['time'] = DateCharDataUpdated($itemraw['member_id']);
			}

			if( isset( $itemdata['quantity'] ) )
			{
				$itemdata['quantity'] += $itemraw['item_quantity'];
			} else {
				$itemdata['quantity'] = $itemraw['item_quantity'];
			}

		}

		$query = "SELECT * FROM `".ROSTER_GB_REQUESTSTABLE."` WHERE item_id LIKE '".$itemid.":%' AND upload = 0 AND deny = 0";

		$result = $wowdb->query($query) or die_quietly($wowdb->error(),'Database Error',basename(__FILE__),__LINE__,$query);
		
		if( $wowdb->num_rows($result) > 0 )
		{
			while( $reqdata = $wowdb->fetch_assoc($result) )
			{
				if( isset($reqitems[$reqdata['member_id']]) )
				{
					$reqitems[$reqdata['member_id']] += $reqdata['item_quantity'];
				} else {
					$reqitems[$reqdata['member_id']] = $reqdata['item_quantity'];
				}
			}
		

			foreach($reqitems as $bankerid => $bankerquan)
			{
				if( isset($itemdata['bankers'][$bankerid]) )
				{
					$itemdata['bankers'][$bankerid] -= $bankerquan;
					$itemdata['quantity'] -= $bankerquan;

					if($itemdata['bankers'][$bankerid] < 1)
					{
						unset($itemdata['bankers'][$bankerid]);
					}
				}
			}
		}

		if($itemdata['quantity'] < 1)
		{

			$content .= border('sblue','start',$wordings[$roster_conf['roster_lang']]['gb_request']);
			$content .= "\n<table cellspacing='0' cellpadding='0'>\n";
			$content .= "\t<tr><td class='membersRow1'>".$wordings[$roster_conf['roster_lang']]['gb_err_notinbank']."</td></tr>\n";
			$content .= "</table>";
			$content .= border('sblue','end');

		} else {

			$content .= border('sblue','start',$wordings[$roster_conf['roster_lang']]['gb_request']);
			$content .= "<form action='index.php' method='get'>\n";	
			$content .= "<input type='hidden' name='name' value='WoWRosterDF'>\n";
			$content .= "<input type='hidden' name='file' value='addon'>\n";
			$content .= "<input type='hidden' name='roster_addon_name' value='guildbank'>\n";
			$content .= "<input type='hidden' name='action' value='requestsub'>\n";
			$content .= "<input type='hidden' name='item' value='".$itemid."'>\n";
			$content .= "\n<table class='bodyline' cellspacing='0' cellpadding='0' align='center'>\n";
			$content .= "\t<tr><td class='membersRow1' rowspan='2'><center>".processItem($itemdata)."</center></td><td class='membersRowRight2'>".$wordings[$roster_conf['roster_lang']]['gb_char'].": ".createMemberlist($name)."</td></tr>\n";
			$content .= "\t<tr><td class='membersRowRight1'>".$wordings[$roster_conf['roster_lang']]['gb_amount'].": <input type='text' name='req_amount' value='1' maxlength='5' size='5'></td></tr>\n";
			$content .= "\t<tr><td class='membersRowRight2' colspan='2' ><center><input type='submit' name='requestsubmit' value='".$wordings[$roster_conf['roster_lang']]['gb_request']."'></center></td></tr>\n";
			$content .= "</table>";
			$content .= "</form>\n";
			$content .= border('sblue','end');

		}

	break;
	case "item_error":
		$content .= border('sblue','start',$wordings[$roster_conf['roster_lang']]['gb_request']);
		$content .= "\n<table cellspacing='0' cellpadding='0'>\n";
		$content .= "\t<tr><td class='membersRow1'>".$wordings[$roster_conf['roster_lang']]['gb_no_item']."</td></tr>\n";
		$content .= "</table>";
		$content .= border('sblue','end');
	break;
	default:
		$content .= border('sblue','start',$wordings[$roster_conf['roster_lang']]['gb_request']);
		$content .= "\n<table cellspacing='0' cellpadding='0'>\n";
		$content .= "\t<tr><td class='membersRow1'>".$wordings[$roster_conf['roster_lang']]['gb_no_action']."</td></tr>\n";
		$content .= "</table>";
		$content .= border('sblue','end');
	break;
}

function createMemberlist($name)
{
	global $wowdb, $addon_conf;

	$list = "<SELECT name='accname'>\n";

	$query = "SELECT member_id, name FROM `".ROSTER_MEMBERSTABLE."` WHERE guild_rank <= ".$addon_conf['guildbank']['rank']." ORDER BY name";
	$result = $wowdb->query($query) or die_quietly($wowdb->error(),'Database Error',basename(__FILE__),__LINE__,$query);

	while( $rawlist = $wowdb->fetch_assoc($result) )
	{
		if( $rawlist['member_id'] === $name )
		{
			$list .= "\t<OPTION SELECTED value='".$rawlist['member_id']."'>".$rawlist['name']."</OPTION>\n";
		} else {
			$list .= "\t<OPTION value='".$rawlist['member_id']."'>".$rawlist['name']."</OPTION>\n";
		}
	}

	$list .= "</SELECT>\n";

	return $list;
}

function processItem($itemrow, $quan = null)
{
	global $color_border, $itemlink, $roster_conf, $wordings;

	// Add the lead to the item-cell
	$returnstr = '<span onmouseover="return overlib(\'';

	// Generate the TOOLTIP code
	$first_line = 1;
	$tooltip = '';
	$itemrow['item']['item_tooltip'] = stripslashes($itemrow['item']['item_tooltip']);
	foreach (explode("\n", $itemrow['item']['item_tooltip']) as $line )
	{
		$color = '';

		if( !empty($line) )
		{
			$line = preg_replace('|\\>|','&#8250;', $line );
			$line = preg_replace('|\\<|','&#8249;', $line );
			$line = preg_replace('|\|c[a-f0-9]{2}([a-f0-9]{6})(.+?)\|r|','<span style="color:#$1;">$2</span>',$line);

			// Do this on the first line
			// This is performed when $caption_color is set
			if( $first_line )
			{
				if( $itemrow['item']['item_color'] == '' )
					$itemrow['item']['item_color'] = '9d9d9d';

				if( strlen($itemrow['item']['item_color']) > 6 )
					$color = substr( $itemrow['item']['item_color'], 2, 6 );
				else
					$color = $itemrow['item']['item_color'];

				$item_color = $color;
				$color .= ';font-size:12px;font-weight:bold';

				$first_line = false;
			}
			else
			{
				if ( ereg('^'.$wordings[$roster_conf['roster_lang']]['tooltip_use'],$line) )
					$color = '00ff00';
				elseif ( ereg('^'.$wordings[$roster_conf['roster_lang']]['tooltip_requires'],$line) )
					$color = 'ff0000';
				elseif ( ereg('^'.$wordings[$roster_conf['roster_lang']]['tooltip_reinforced'],$line) )
					$color = '00ff00';
				elseif ( ereg('^'.$wordings[$roster_conf['roster_lang']]['tooltip_equip'],$line) )
					$color = '00ff00';
				elseif ( ereg('^'.$wordings[$roster_conf['roster_lang']]['tooltip_chance'],$line) )
					$color = '00ff00';
				elseif ( ereg('^'.$wordings[$roster_conf['roster_lang']]['tooltip_enchant'],$line) )
					$color = '00ff00';
				elseif ( ereg('^'.$wordings[$roster_conf['roster_lang']]['tooltip_soulbound'],$line) )
					$color = '00bbff';
				elseif ( ereg('^'.$wordings[$roster_conf['roster_lang']]['tooltip_set'],$line) )
					$color = '00ff00';
				elseif ( preg_match('|\([a-f0-9]\).'.$wordings[$roster_conf['roster_lang']]['tooltip_set'].'|',$line) )
					$color = '666666';
				elseif ( ereg('^\\"',$line) )
					$color = 'ffd517';
			}

			// Convert tabs to a formated table
			if( strpos($line,"\t") )
			{
				$line = str_replace("\t",'</td><td align="right" class="overlib_maintext">', $line);
				$line = '<table width="100%" cellspacing="0" cellpadding="0"><tr><td class="overlib_maintext">'.$line.'</td></tr></table>';
				$tooltip .= $line;
			}
			elseif( !empty($color) )
			{
				$tooltip .= '<span style="color:#'.$color.';">'.$line.'</span><br />';
			}
			else
			{
				$tooltip .= "$line<br />";
			}
		}
		else
		{
			$tooltip .= '<br />';
		}
	}

	if (!isset($tooltip))
		$tooltip = $tooltip_out;

	// Process a line for each Banker that holds 'quantity' of the item inside the Tooltip
	foreach ($itemrow['bankers'] as $itemBankerID => $BankerData)
	{
		$tooltip = '<span style="color:#5c82a3;">'.$itemrow['bankernames'][$itemBankerID]['name'].'</span> ('.$BankerData.') - <span style="color:#aaaaaa; font-size:8pt;">Time:'.$itemrow['bankernames'][$itemBankerID]['time'].'</span><hr />' . $tooltip;
	}
	// Normalize the tooltip string
	$tooltip = str_replace("'", "\'", $tooltip);
	$tooltip = str_replace('"','&quot;', $tooltip);

	$returnstr .= $tooltip.'\');" onmouseout="return nd();">'."\n";
	// Free Up memory by clearing the tooltip string
	$tooltip = '';

	// Get the Icon Color
	switch ($item_color)
	{
		case "ffffff":
			$item_quality = "iconwhite";
		break;
		case "1eff00":
			$item_quality = "icongreen";
		break;
		case "9d9d9d":
			$item_quality = "icongrey";
		break;
		case "0070dd":
			$item_quality = "iconblue";
		break;
		default:
			$item_quality = "iconpurple";
	}
	$returnstr .= '<div class="item">';

	// Clean the Item Texture of backslashes and replace them with forward slashes
	$item_texture=str_replace('\\','/',$itemrow['item']['item_texture']);

	// Construct the image with a URL and put the colored border around it
	if ($color_border)
	{
		$returnstr .=  '<a href="'.$itemlink[$roster_conf['roster_lang']].urlencode(utf8_decode($itemrow['item']['real_id'])).'" target="_blank">'."\n".'<img src="'.$roster_conf['interface_url'].$item_texture.'.'.$roster_conf['img_suffix'].'" class="'.$item_quality.'" alt="'.$itemrow['item']['item_name'].'"></a>';
	}
	else
	{
		$returnstr .=  '<a href="'.$itemlink[$roster_conf['roster_lang']].urlencode(utf8_decode($itemrow['item']['real_id'])).'" target="_blank">'."\n".'<img src="'.$roster_conf['interface_url'].$item_texture.'.'.$roster_conf['img_suffix'].'" alt="'.$itemrow['item']['item_name'].'"></a>';
	}

	if($quan !== NULL)
	{
		$itemrow['quantity'] -= intval($quan);
	}

	// If we have more than 1 in total, display the total quantity number on the image
	if ($itemrow['quantity'] > 1)
	{
		$returnstr .= '<span class="quant">'.$itemrow['quantity'].'</span>';
	}
	// Add the trail to the item-cell
	$returnstr .= '</div></span>';

	// Return the complete table cell for the item
	return $returnstr;
}

function DateCharDataUpdated($member_id)
{
	global $wowdb, $roster_conf, $phptimeformat;

	$query1 = "SELECT `dateupdatedutc` FROM `".ROSTER_PLAYERSTABLE."` WHERE `member_id` = '$member_id'";
	$result1 = $wowdb->query($query1);
	$data1 = $wowdb->fetch_assoc($result1);
	$dateupdatedutc = $data1['dateupdatedutc'];

	list($month,$day,$year,$hour,$minute,$second) = sscanf($dateupdatedutc,"%2d/%2d/%2d %2d:%2d:%2d");
	$localtime = mktime($hour+$roster_conf['localtimeoffset'] ,$minute, $second, $month, $day, $year, -1);
	return date($phptimeformat[$roster_conf['roster_lang']], $localtime);
}

?>
